## org.firebirdsql.jdbc
Class FBDatabaseMetaData

    java.lang.Object
      org.firebirdsql.jdbc.AbstractDatabaseMetaData
          org.firebirdsql.jdbc.FBDatabaseMetaData

All Implemented Interfaces:
  DatabaseMetaData, Wrapper, FirebirdDatabaseMetaData

    public class FBDatabaseMetaData

extends AbstractDatabaseMetaData

Field Summary

Fields inherited from class org.firebirdsql.jdbc.AbstractDatabaseMetaData
`ALL_TYPES, GET_COLUMNS_END, SYSTEM_TABLE, TABLE, VIEW`

Fields inherited from interface java.sql.DatabaseMetaData

`attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL, sqlStateSQL99, sqlStateXOpen, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

Constructor Summary
`FBDatabaseMetaData(AbstractConnection c)`
`FBDatabaseMetaData(GDSHelper gdsHelper)`

Method Summary
`boolean` `autoCommitFailureClosesAllResultSets()`
`ResultSet` `getClientInfoProperties()` Retrieves a list of the client info properties that the driver supports.
`ResultSet` `getFunctionColumns(String catalog, String schemaPattern, String functionNamePattern, String columnNamePattern)` Retrieves a description of the given catalog's system or user function parameters and return type.
`ResultSet` `getFunctions(String catalog, String schemaPattern, String functionNamePattern)` Retrieves a description of the system and user functions available in the given catalog.
`RowIdLifetime` `getRowIdLifetime()` Indicates whether or not this data source supports the SQL `ROWID` type, and if so the lifetime for which a `RowId` object remains valid.
`ResultSet` `getSchemas(String catalog, String schemaPattern)` Retrieves the schema names available in this database.
`boolean` `isWrapperFor(Class arg0)`
`boolean` `supportsStoredFunctionsUsingCallSyntax()`
`Object` `unwrap(Class arg0)`

Methods inherited from class org.firebirdsql.jdbc.AbstractDatabaseMetaData

`allProceduresAreCallable, allTablesAreSelectable, dataDefinitionCausesTransactionCommit, dataDefinitionIgnoredInTransactions, deletesAreDetected, doesMaxRowSizeIncludeBlobs, doQuery, getAttributes, getBestRowIdentifier, getCatalogs, getCatalogSeparator, getCatalogTerm, getColumnPrivileges, getColumns, getConnection, getCrossReference, getDatabaseMajorVersion, getDatabaseMinorVersion, getDatabaseProductName, getDatabaseProductVersion, getDefaultTransactionIsolation, getDriverMajorVersion, getDriverMinorVersion, getDriverName, getDriverVersion, getExportedKeys, getExtraNameCharacters, getIdentifierQuoteString, getImportedKeys, getIndexInfo, getJDBCMajorVersion, getJDBCMinorVersion, getMaxBinaryLiteralLength, getMaxCatalogNameLength, getMaxCharLiteralLength, getMaxColumnNameLength, getMaxColumnsInGroupBy, getMaxColumnsInIndex, getMaxColumnsInOrderBy, getMaxColumnsInSelect, getMaxColumnsInTable, getMaxConnections, getMaxCursorNameLength, getMaxIndexLength, getMaxProcedureNameLength, getMaxRowSize, getMaxSchemaNameLength, getMaxStatementLength, getMaxStatements, getMaxTableNameLength, getMaxTablesInSelect, getMaxUserNameLength, getNumericFunctions, getPrimaryKeys, getProcedureColumns, getProcedures, getProcedureSourceCode, getProcedureTerm, getResultSetHoldability, getSchemas, getSchemaTerm, getSearchStringEscape, getSQLKeywords, getSQLStateType, getStringFunctions, getSuperTables, getSuperTypes, getSystemFunctions, getTablePrivileges, getTables, getTableTypes, getTimeDateFunctions, getTriggerSourceCode, getTypeInfo, getUDTs, getURL, getUserName, getVersionColumns, getViewSourceCode, hasNoWildcards, insertsAreDetected, isCatalogAtStart, isReadOnly, locatorsUpdateCopy, nullPlusNonNullIsNull, nullsAreSortedAtEnd, nullsAreSortedAtStart, nullsAreSortedHigh, nullsAreSortedLow, othersDeletesAreVisible, othersInsertsAreVisible, othersUpdatesAreVisible, ownDeletesAreVisible, ownInsertsAreVisible, ownUpdatesAreVisible, storesLowerCaseIdentifiers, storesLowerCaseQuotedIdentifiers, storesMixedCaseIdentifiers, storesMixedCaseQuotedIdentifiers, storesUpperCaseIdentifiers, storesUpperCaseQuotedIdentifiers, stripEscape, stripQuotes, supportsAlterTableWithAddColumn, supportsAlterTableWithDropColumn, supportsANSI92EntryLevelSQL, supportsANSI92FullSQL, supportsANSI92IntermediateSQL, supportsBatchUpdates, supportsCatalogsInDataManipulation, supportsCatalogsInIndexDefinitions, supportsCatalogsInPrivilegeDefinitions, supportsCatalogsInProcedureCalls, supportsCatalogsInTableDefinitions, supportsColumnAliasing, supportsConvert, supportsConvert, supportsCoreSQLGrammar, supportsCorrelatedSubqueries, supportsDataDefinitionAndDataManipulationTransactions, supportsDataManipulationTransactionsOnly, supportsDifferentTableCorrelationNames, supportsExpressionsInOrderBy, supportsExtendedSQLGrammar, supportsFullOuterJoins, supportsGetGeneratedKeys, supportsGroupBy, supportsGroupByBeyondSelect, supportsGroupByUnrelated, supportsIntegrityEnhancementFacility, supportsLikeEscapeClause, supportsLimitedOuterJoins, supportsMinimumSQLGrammar, supportsMixedCaseIdentifiers, supportsMixedCaseQuotedIdentifiers, supportsMultipleOpenResults, supportsMultipleResultSets, supportsMultipleTransactions, supportsNamedParameters, supportsNonNullableColumns, supportsOpenCursorsAcrossCommit, supportsOpenCursorsAcrossRollback, supportsOpenStatementsAcrossCommit, supportsOpenStatementsAcrossRollback, supportsOrderByUnrelated, supportsOuterJoins, supportsPositionedDelete, supportsPositionedUpdate, supportsResultSetConcurrency, supportsResultSetHoldability, supportsResultSetType, supportsSavepoints, supportsSchemasInDataManipulation, supportsSchemasInIndexDefinitions, supportsSchemasInPrivilegeDefinitions, supportsSchemasInProcedureCalls, supportsSchemasInTableDefinitions, supportsSelectForUpdate, supportsStatementPooling, supportsStoredProcedures, supportsSubqueriesInComparisons, supportsSubqueriesInExists, supportsSubqueriesInIns, supportsSubqueriesInQuantifieds, supportsTableCorrelationNames, supportsTransactionIsolationLevel, supportsTransactions, supportsUnion, supportsUnionAll, updatesAreDetected, usesLocalFilePerTable, usesLocalFiles`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FBDatabaseMetaData

    public FBDatabaseMetaData(AbstractConnection c)
                       throws GDSException

Throws:
  `GDSException`

### FBDatabaseMetaData

    public FBDatabaseMetaData(GDSHelper gdsHelper)

Method Detail

### supportsStoredFunctionsUsingCallSyntax

    public boolean supportsStoredFunctionsUsingCallSyntax()
                                                   throws SQLException

  Throws:
    `SQLException`

### autoCommitFailureClosesAllResultSets

    public boolean autoCommitFailureClosesAllResultSets()
                                                 throws SQLException

  Throws:
    `SQLException`

### getClientInfoProperties

    public ResultSet getClientInfoProperties()
                                      throws SQLException

  Retrieves a list of the client info properties that the driver supports. The result set contains the following columns

  1. NAME String=> The name of the client info property
  2. MAX_LEN int=> The maximum length of the value for the property
  3. DEFAULT_VALUE String=> The default value of the property
  4. DESCRIPTION String=> A description of the property. This will typically contain information as to where this property is stored in the database.

  The `ResultSet` is sorted by the NAME column

  Returns:
    A `ResultSet` object; each row is a supported client info property

  Throws:
    `SQLException` - if a database access error occurs

  Since:
    1.6

### getFunctionColumns

    public ResultSet getFunctionColumns(String catalog,
                                        String schemaPattern,
                                        String functionNamePattern,
                                        String columnNamePattern)
                                 throws SQLException

  Retrieves a description of the given catalog's system or user function parameters and return type.

  Only descriptions matching the schema, function and parameter name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the `ResultSet` is a parameter description, column description or return type description with the following fields:

  1. FUNCTION_CAT String => function catalog (may be `null`)
  2. FUNCTION_SCHEM String => function schema (may be `null`)
  3. FUNCTION_NAME String => function name. This is the name used to invoke the function
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - functionColumnUnknown - nobody knows
     - functionColumnIn - IN parameter
     - functionColumnInOut - INOUT parameter
     - functionColumnOut - OUT parameter
     - functionColumnReturn - function return value
     - functionColumnResult - Indicates that the parameter or column is a column in the `ResultSet`
  6. DATA_TYPE int => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale - null is returned for data types where SCALE is not applicable.
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL.
      - functionNoNulls - does not allow NULL values
      - functionNullable - allows NULL values
      - functionNullableUnknown - nullability unknown
  13. REMARKS String => comment describing column/parameter
  14. CHAR_OCTET_LENGTH int => the maximum length of binary and character based parameters or columns. For any other datatype the returned value is a NULL
  15. ORDINAL_POSITION int => the ordinal position, starting from 1, for the input and output parameters. A value of 0 is returned if this row describes the function's return value. For result set columns, it is the ordinal position of the column in the result set starting from 1.
  16. IS_NULLABLE String => ISO rules are used to determine the nullability for a parameter or column.
      - YES --- if the parameter or column can include NULLs
      - NO --- if the parameter or column cannot include NULLs
      - empty string --- if the nullability for the parameter or column is unknown
  17. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

  The PRECISION column represents the specified column size for the given parameter or column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `functionNamePattern` - a procedure name pattern; must match the function name as it is stored in the database
    `columnNamePattern` - a parameter name pattern; must match the parameter or column name as it is stored in the database
  Returns:
    `ResultSet` - each row describes a user function parameter, column or return type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.6
  See Also:
    `AbstractDatabaseMetaData.getSearchStringEscape()`

### getFunctions

    public ResultSet getFunctions(String catalog,
                                  String schemaPattern,
                                  String functionNamePattern)
                           throws SQLException

  Retrieves a description of the system and user functions available in the given catalog.

  Only system and user function descriptions matching the schema and function name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`.

  Each function description has the the following columns:

  1. FUNCTION_CAT String => function catalog (may be `null`)
  2. FUNCTION_SCHEM String => function schema (may be `null`)
  3. FUNCTION_NAME String => function name. This is the name used to invoke the function
  4. REMARKS String => explanatory comment on the function
  5. FUNCTION_TYPE short => kind of function:
     - functionResultUnknown - Cannot determine if a return value or table will be returned
     - functionNoTable- Does not return a table
     - functionReturnsTable - Returns a table
  6. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

  A user may not have permission to execute any of the functions that are returned by `getFunctions`

  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `functionNamePattern` - a function name pattern; must match the function name as it is stored in the database
  Returns:
    `ResultSet` - each row is a function description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.6
  See Also:
    `AbstractDatabaseMetaData.getSearchStringEscape()`

### getRowIdLifetime

    public RowIdLifetime getRowIdLifetime()
                                   throws SQLException

  Indicates whether or not this data source supports the SQL `ROWID` type, and if so the lifetime for which a `RowId` object remains valid.

  The returned int values have the following relationship:

           ROWID_UNSUPPORTED < ROWID_VALID_OTHER < ROWID_VALID_TRANSACTION
               < ROWID_VALID_SESSION < ROWID_VALID_FOREVER

  so conditional logic such as

           if (metadata.getRowIdLifetime() > DatabaseMetaData.ROWID_VALID_TRANSACTION)

  can be used. Valid Forever means valid across all Sessions, and valid for a Session means valid across all its contained Transactions.

  Returns:
    the status indicating the lifetime of a `RowId`
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.6

### getSchemas

    public ResultSet getSchemas(String catalog,
                                String schemaPattern)
                         throws SQLException

  Retrieves the schema names available in this database. The results are ordered by `TABLE_CATALOG` and `TABLE_SCHEM`.

  The schema columns are:

  1. TABLE_SCHEM String => schema name
  2. TABLE_CATALOG String => catalog name (may be `null`)

  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database;"" retrieves those without a catalog; null means catalog name should not be used to narrow down the search.
    `schemaPattern` - a schema name; must match the schema name as it is stored in the database; null means schema name should not be used to narrow down the search.
  Returns:
    a `ResultSet` object in which each row is a schema description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.6
  See Also:
    `AbstractDatabaseMetaData.getSearchStringEscape()`

### isWrapperFor

    public boolean isWrapperFor(Class arg0)
                         throws SQLException

  Throws:
    `SQLException`

### unwrap

    public Object unwrap(Class arg0)
                  throws SQLException

  Throws:
    `SQLException`

Copyright © 2001-2010. All Rights Reserved.